/*
  Copyright (C) 2004 Pavel Lajsner <ok2ucx@qsl.net>.

  This file is part of the Weather station system.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, 
  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $File Name        : onewire.h$
  $Date             : Feb-20-2004$
  $Version          : 1.1.4.0$ 
  $Last Modified By : r30323$

*/

#define LOW 0
#define HIGH 1
#define WIREPORT PTA1
#define WIREDDR  DDRA_BIT1
#define WIREPUE  PTAPUE_BIT1

#define WireLow() {WIREPORT = LOW; WIREDDR = 1;}
#define WireHigh() {WIREPORT = HIGH; WIREDDR = 0;}
#define WireStrong() {WIREPORT = HIGH; WIREDDR = 1;}

#define Wait1us() {asm nop;asm nop;asm nop;}

#define US(N) (N-3)

#define RES 10 /* final resolution */

extern void Wait_us(char n);
extern void wire_send(char ch);
extern char wire_recv_bit(void);
extern char wire_recv(void);
extern char wire_present(void);
extern int OneWire(char *errcode);

#pragma DATA_SEG SHORT _DATA_ZEROPAGE

extern int temperature;
#pragma DATA_SEG DEFAULT
